package com.landray.kmss.sys.attachment.actions;

import com.landray.kmss.web.config.IActionConfig;
import java.util.Map;
import com.landray.kmss.web.config.ForwardConfig;
import java.util.List;
import com.landray.kmss.util.KmssReturnPage;
import com.landray.kmss.util.UserUtil;
import org.json.simple.JSONObject;
import com.landray.kmss.util.KmssMessages;
import com.landray.kmss.common.test.TimeCounter;
import com.landray.kmss.util.CriteriaUtil;
import com.landray.kmss.util.CriteriaValue;
import com.landray.kmss.common.actions.RequestContext;
import com.landray.kmss.sys.attachment.model.SysAttBase;
import com.sunbor.web.tag.Page;
import com.landray.kmss.sys.attachment.model.SysAttDownloadLog;
import com.landray.kmss.sys.log.util.UserOperHelper;
import com.landray.kmss.util.ModelUtil;
import com.landray.kmss.util.StringUtil;
import com.landray.kmss.common.dao.HQLInfo;
import org.apache.commons.lang3.StringUtils;
import com.landray.kmss.web.action.ActionForward;
import javax.servlet.http.HttpServletResponse;
import com.landray.kmss.web.action.ActionForm;
import com.landray.kmss.web.action.ActionMapping;
import com.landray.kmss.common.service.IBaseService;
import javax.servlet.http.HttpServletRequest;
import com.landray.kmss.sys.attachment.service.ISysAttMainCoreInnerService;
import com.landray.kmss.sys.attachment.service.ISysAttDownloadLogService;
import com.landray.kmss.common.actions.ExtendAction;

public class SysAttDownloadLogAction extends ExtendAction
{
    private ISysAttDownloadLogService sysAttDownloadLogService;
    protected ISysAttMainCoreInnerService sysAttMainService;
    
    protected IBaseService getServiceImp(final HttpServletRequest request) {
        if (this.sysAttDownloadLogService == null) {
            this.sysAttDownloadLogService = (ISysAttDownloadLogService)this.getBean("sysAttDownloadLogService");
        }
        return (IBaseService)this.sysAttDownloadLogService;
    }
    
    protected ISysAttMainCoreInnerService getSysAttMainService() {
        if (this.sysAttMainService == null) {
            this.sysAttMainService = (ISysAttMainCoreInnerService)this.getBean("sysAttMainService");
        }
        return this.sysAttMainService;
    }
    
    public ActionForward view(final ActionMapping mapping, final ActionForm form, final HttpServletRequest request, final HttpServletResponse response) throws Exception {
        return mapping.findForward("view");
    }
    
    public ActionForward list(final ActionMapping mapping, final ActionForm form, final HttpServletRequest request, final HttpServletResponse response) throws Exception {
        try {
            final String s_pageno = request.getParameter("pageno");
            final String s_rowsize = request.getParameter("rowsize");
            String orderby = request.getParameter("orderby");
            final String ordertype = request.getParameter("ordertype");
            int pageNo = 0;
            int rowSize = 0;
            if (s_pageno != null && s_pageno.length() > 0) {
                pageNo = Integer.parseInt(s_pageno);
            }
            if (s_rowsize != null && s_rowsize.length() > 0) {
                rowSize = Integer.parseInt(s_rowsize);
            }
            boolean isReserve = false;
            if (ordertype != null && "down".equalsIgnoreCase(ordertype)) {
                isReserve = true;
            }
            if (isReserve) {
                orderby = String.valueOf(orderby) + " desc";
            }
            String modelId = request.getParameter("modelId");
            final String queryModelId = request.getParameter("q.modelId");
            if (StringUtils.isNotBlank(queryModelId)) {
                modelId = queryModelId;
            }
            final String modelName = request.getParameter("modelName");
            Page page = null;
            final HQLInfo hqlInfo = new HQLInfo();
            hqlInfo.setOrderBy(orderby);
            hqlInfo.setRowSize(rowSize);
            hqlInfo.setPageNo(pageNo);
            this.changeFindPageHQLInfo(request, hqlInfo);
            if (StringUtil.isNotNull(modelId) && StringUtil.isNotNull(modelName)) {
                String whereBlock = hqlInfo.getWhereBlock();
                if (StringUtil.isNull(whereBlock)) {
                    whereBlock = "";
                }
                else {
                    whereBlock = "(" + whereBlock + ") and ";
                }
                final String tableName = ModelUtil.getModelTableName((Object)this.getServiceImp(request).getModelName());
                whereBlock = String.valueOf(whereBlock) + tableName + ".fdModelName = :fdModelName and " + tableName + ".fdModelId = :fdModelId";
                hqlInfo.setWhereBlock(whereBlock);
                ((ISysAttDownloadLogService)this.getServiceImp(request)).includeRecord(hqlInfo);
                hqlInfo.setParameter("fdModelName", (Object)modelName);
                hqlInfo.setParameter("fdModelId", (Object)modelId);
            }
            page = this.getServiceImp(request).findPage(hqlInfo);
            request.setAttribute("queryPage", (Object)page);
            if (UserOperHelper.allowLogOper("Action_FindAll", (String)null)) {
                UserOperHelper.logFindAll(page.getList(), SysAttDownloadLog.class.getName());
            }
        }
        catch (final Exception e) {
            e.printStackTrace();
        }
        return mapping.findForward("list");
    }
    
    public ActionForward addDownlodLog(final ActionMapping mapping, final ActionForm form, final HttpServletRequest request, final HttpServletResponse response) throws Exception {
        final String attId = request.getParameter("fdId");
        if (StringUtil.isNotNull(attId)) {
            final SysAttBase attModel = (SysAttBase)this.getSysAttMainService().findByPrimaryKey(attId);
            ((ISysAttDownloadLogService)this.getServiceImp(request)).addDownloadLogByAtt(attModel, new RequestContext(request));
        }
        return null;
    }
    
    protected void changeFindPageHQLInfo(final HttpServletRequest request, final HQLInfo hqlInfo) throws Exception {
        super.changeFindPageHQLInfo(request, hqlInfo);
        final CriteriaValue cv = new CriteriaValue(request);
        CriteriaUtil.buildHql(cv, hqlInfo, (Class)SysAttDownloadLog.class);
        final String tableName = ModelUtil.getModelTableName((Object)this.getServiceImp(request).getModelName());
        String whereBlock = hqlInfo.getWhereBlock();
        final String fileName = cv.poll("fdFileName");
        if (StringUtil.isNotNull(fileName)) {
            whereBlock = StringUtil.linkString(whereBlock, " and ", String.valueOf(tableName) + ".fdFileName like :fdFileName");
            hqlInfo.setParameter("fdFileName", (Object)("%" + fileName + "%"));
        }
        final String docCreatorId = cv.poll("docCreator");
        if (StringUtil.isNotNull(docCreatorId)) {
            whereBlock = StringUtil.linkString(whereBlock, " and ", String.valueOf(tableName) + ".docCreatorId = :docCreatorId");
            hqlInfo.setParameter("docCreatorId", (Object)docCreatorId);
        }
        hqlInfo.setWhereBlock(whereBlock);
    }
    
    public ActionForward count(final ActionMapping mapping, final ActionForm form, final HttpServletRequest request, final HttpServletResponse response) throws Exception {
        TimeCounter.logCurrentTime("Action-count", true, (Class)this.getClass());
        final KmssMessages messages = new KmssMessages();
        try {
            final JSONObject json = new JSONObject();
            final HQLInfo hqlInfo = new HQLInfo();
            hqlInfo.setGettingCount(true);
            final String type = request.getParameter("type");
            if ("create".equals(type)) {
                hqlInfo.setWhereBlock("sysAttDownloadLog.docCreatorId =:docCreatorId");
                hqlInfo.setParameter("docCreatorId", (Object)UserUtil.getUser().getFdId());
            }
            hqlInfo.setSelectBlock("count(distinct sysAttDownloadLog.fdId)");
            final List<Long> count = this.getServiceImp(request).findValue(hqlInfo);
            json.put((Object)"count", (Object)count.get(0));
            request.setAttribute("lui-source", (Object)json);
        }
        catch (final Exception e) {
            messages.addError((Throwable)e);
        }
        TimeCounter.logCurrentTime("Action-count", false, (Class)this.getClass());
        if (messages.hasError()) {
            KmssReturnPage.getInstance(request).addMessages(messages).save(request);
            return this.getActionForward("failure", mapping, form, request, response);
        }
        KmssReturnPage.getInstance(request).addMessages(messages).addButton(0).save(request);
        return this.getActionForward("lui-source", mapping, form, request, response);
    }
}
